<!--- lines to modify as needed:
18: where is the configuration file located?
62: set root directory, folder that each user will explore

if you use ftp, then you will also need to change lines 33 (when running in application mode or 61 when running in session mode)
 --->
<cfcomponent displayname="Application">	
<cfsilent>
	<cfscript>
		this.name = "ASF_FileExplorer_ftp";
		this.setclientcookies="false";
		this.sessionmanagement = "yes";
		this.sessiontimeout = CreateTimeSpan(0,0,30,0);
		
		//where the ini configuration file is located, it assumes it is located
		//in the same directory as this file, but if you move it to a different directory,
		//for example if you you transferred it to a non-web accessible directory for security, change as needed
		variables.config = GetDirectoryFromPath(GetCurrentTemplatePath()) & "fileexplorer.ini";
	</cfscript>
</cfsilent>
	<!--- ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: --->
	<cffunction name="OnApplicationStart">
	
		<!--- set some variables in the application scope --->
		<cfset application.fileManager = structnew()/>
		<cfset application.fileManager.typesWithIcons = GetProfileString(variables.config, "default", "typesWithIcons") />
		<cfset application.fileManager.servicespath = GetProfileString(variables.config, "default", "servicesPath") />
		<cfset application.fileManager.treeRootLabel = GetProfileString(variables.config, "default", "treeRootLabel") />
		<cfset application.fileManager.allowedExtensions = GetProfileString(variables.config, "default", "allowedExtensions") />
		<cfset application.fileManager.allowedExtensionsDescription = GetProfileString(variables.config, "default", "allowedExtensionsDescription") />
		
		<!--- only create the object on the application if we are using application storage as opposed to session storage --->
		<cfif GetProfileString(variables.config, "default", "managerStorage") EQ "application">			
			
			<cfset application.fileManager.manager = createObject("component",GetProfileString(variables.config, "default", "managerComponent")).init(GetProfileString(variables.config, "default", "server"),GetProfileString(variables.config, "default", "username"),GetProfileString(variables.config, "default", "password"),GetProfileString(variables.config, "default", "allowedExtensions")) />
		</cfif>		
		
	</cffunction>
		
	
	<!--- ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: --->
 	<cffunction name="onSessionStart">
			<cfset var rootDir = ""/>
			
			<cfif GetProfileString(variables.config, "default", "managerStorage") EQ "application">
				<!--- if storage type is application, all the users will get the same file manager object (and therefore the same root folder to explore) --->
				<cfset session.fileManager = application.fileManager.manager />
			<cfelse>
				<!--- assume it is session-based storage.
						You will need to set your own root directory, you can use 
						the root variable if all your users have some common 
						directory and then you could append some user-specific variable
						such as their userid. You know your application better than I do,
						so it is up to you!
						
						Example:
						<cfset rootDir = GetProfileString(variables.config, "default", "rootdirectory") & session.userid & "\pictures\" />
						  --->
				<!--- modify this as needed --->
				<cfset rootDir = GetProfileString(variables.config, "default", "rootDirectory") />
				
				<!--- create the object for this session --->
				 <cfset session.fileManager = createObject("component",GetProfileString(variables.config, "default", "managerComponent")).init(GetProfileString(variables.config, "default", "server"),GetProfileString(variables.config, "default", "username"),GetProfileString(variables.config, "default", "password"),GetProfileString(variables.config, "default", "allowedExtensions")) />
			</cfif>
		
	</cffunction>
	
	
	<!--- ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: --->
	<cffunction name="onRequestStart" returnType="boolean">
		<cfargument type="String" name="targetPage" required="true" />
			<cfsilent>
			<cfset request.fileManagerProps = application.fileManager />
			</cfsilent>
		<cfreturn true>
	</cffunction>
	
	
</cfcomponent>